package orderprocessing;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/** This class manages inventory and responds to requests from an OrderProcessor
*   In this version it is just a stub. It says that anything is in stock and does
*   no error checking of any kind.
*/
public class InventoryManager
{	public InventoryManager(){}

	/** Tells if a given order can be filled now
	*	@ param order The OrderItem to be checked.
	*	@ return an OrderItem with the quantity that can be shipped.
	*/
	public OrderItem available(OrderItem order)
	{	return (OrderItem)order.clone();
	}

	public static InventoryManager standardInventoryManager = new InventoryManager();

	public static final void close(ObjectOutputStream out) throws IOException
	{	// Nothing yet
	}

	public static final void open(ObjectInputStream in) throws IOException, ClassNotFoundException
	{	// Nothing yet
	}

}
