package orderprocessing;
import junit.framework.*;

public class OrderItemTest extends TestCase // fixture
{	private OrderItem o123;
	private OrderItem o124;
	
	public OrderItemTest(String s){super(s);} // Always required. Omitted from documentation.
	
	protected void setUp()
	{	o123 = new OrderItem(10, 123, 2.34, "widget");
		o124 = new OrderItem(10, 124, 5.67, "foofra"); 
		// Create new objects here, not in the declarations. 
        // You want the creation repeated for each test.
		// This makes a series of tests "memoryless" so they don't depend on each other. 
        // You are therefore guaranteed to start in a known state for each test. 
	}
	protected void tearDown() throws Exception
	{	super.tearDown(); 
		// Actually nothing is needed here for this example.
		// You may need to release resources (files, say) in this method.
	}
	
	public void testEquals()
	{	// assert(!o123.equals(null)); Not needed, the system catches null reference failures. 
		assertEquals ("OrderItem equality failure", o123, new OrderItem(10, 123, 2.34, "widget"));
		assert("OrderItem inequality failure", !o123.equals(o124));
	}
	
	public void testClone()
	{	assertEquals("OrderItem clone failure", o123, o123.clone());
		assert("OrderItem hashCode failure.", o123.hashCode() == o123.clone().hashCode());
	}
	
	public static Test suite()
	{	TestSuite suite = new TestSuite();
		suite.addTest(new OrderItemTest("testClone"));
		suite.addTest(new OrderItemTest("testEquals"));
		return suite;
	}
	
	public static void main(String [] args) // The batch interface: 
	{	junit.textui.TestRunner.run(suite());
	}
	
	/* Usage: Assuming that the junit directory is junit3.2 (at root level),
	the run command for the textual interface system for this test is
	java -cp .;/junit3.2/junit.jar orderprocessing.OrderItemTest
	Or make the orderprocessing.OrderItemTest class your "main" class 
    in KAWA or other project mgr.
	
	Alternatively, to use the GUI interface to the test infrastructure. The batch command is
	java -cp .;/junit3.2/junit.jar junit.ui.TestRunner
	*/
}

