package orderprocessing;

import java.util.HashMap;
import java.util.Iterator;

/** Represents a product sold by the firm. There is a record for each kind of
 *  thing sold. The class also maintains a hashmap of all the products.
 */
public class Product // Immutable
{	public Product(double price, String description)
	{	this.ID = IDGenerator.nextID();
		this.price = price;
        this.description = description;
        allProducts.put(ID, this);
	}

    public String key()
    {	return ID;
    }

    public String description()
    {	return description;
    }

    public double price()
    {	return price;
    }

    private String ID;
    private double price;
    private String description;

    private static class IDGenerator
    {	public static String nextID()
        {	 return ID_PREFIX + Long.toString(nextID++);
        }

        private static long             nextID   = 4001;
        private final static String     ID_PREFIX = "P";
    }

    private static HashMap allProducts = new HashMap();

    public static Product get(String id)
    {	return (Product)allProducts.get(id);
    }

    public static Iterator keys()
    {	return allProducts.keySet().iterator();
    }

}
